﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using System.Text;
using System.Data.SqlClient;
using System.Collections;
using System.Configuration;

public partial class _Default : System.Web.UI.Page
{
	private int _userID = 2;
	private SqlConnection _conn = new SqlConnection(ConfigurationManager.ConnectionStrings["DockConnectionString"].ConnectionString);
	private List<DockState> CurrentDockStates
	{
		get
		{
			//Get saved state string from the database - set it to dockState variable for example 
			string dockStatesFromDB = "";
			_conn.Open();
			SqlCommand command = new SqlCommand("select State from States where id='" + _userID + "' ", _conn);
			dockStatesFromDB = command.ExecuteScalar().ToString();
			_conn.Close();

			List<DockState> _currentDockStates = new List<DockState>();
			string[] stringStates = dockStatesFromDB.Split('|');
			foreach (string stringState in stringStates)
			{
				if (stringState.Trim() != string.Empty)
				{
					_currentDockStates.Add(DockState.Deserialize(stringState));
				}
			}
			return _currentDockStates;
		}
	}

	protected void Page_Load(object sender, EventArgs e)
	{
		if (!IsPostBack)
		{
			DropDownZone.DataBind();
		}
	}

	protected override void OnInit(EventArgs e)
	{
		base.OnInit(e);

		string zoneStatesFromDB = "";

		_conn.Open();
		SqlCommand command = new SqlCommand("SELECT zonestate from States where id='" + _userID + "' ", _conn);
		zoneStatesFromDB = command.ExecuteScalar().ToString();
		_conn.Close();


		string[] zoneStateArray = zoneStatesFromDB.Split('|');
		foreach (string uniqueName in zoneStateArray)
		{
			if (uniqueName.Trim() != string.Empty)
			{
				RadDockZone zone = CreateZoneFromState(uniqueName);
				RadDockLayout1.Controls.Add(zone);
			}
		}


		//Recreate the docks in order to ensure their proper operation
		for (int i = 0; i < CurrentDockStates.Count; i++)
		{
			if (CurrentDockStates[i].Closed == false)
			{
				RadDock dock = CreateRadDockFromState(CurrentDockStates[i]);
				RadDockLayout1.Controls.Add(dock);
				CreateSaveStateTrigger(dock);
				LoadWidget(dock);
			}
		}

	}

	protected void RadDockLayout1_LoadDockLayout(object sender, DockLayoutEventArgs e)
	{
		foreach (DockState state in CurrentDockStates)
		{
			// Comment these two lines and you will see that the indices are not applied correctly

			e.Positions[state.UniqueName] = state.DockZoneID;
			e.Indices[state.UniqueName] = state.Index;
		}
	}

	protected void RadDockLayout1_SaveDockLayout(object sender, DockLayoutEventArgs e)
	{
		List<DockState> stateList = RadDockLayout1.GetRegisteredDocksState();
		StringBuilder serializedList = new StringBuilder();
		int i = 0;

		while (i < stateList.Count)
		{
			serializedList.Append(stateList[i].ToString());
			serializedList.Append("|");
			i++;
		}

		List<RadDockZone> registeredZones = RadDockLayout1.RegisteredZones.ToList<RadDockZone>();
		StringBuilder serializedZoneList = new StringBuilder();
		for (i = 0; i < registeredZones.Count; i++)
		{
			serializedZoneList.Append(registeredZones[i].UniqueName);
			serializedZoneList.Append("|");
		}

		string zoneState = serializedZoneList.ToString();
		string dockState = serializedList.ToString();



		if (dockState.Trim() != String.Empty || zoneState.Trim() != String.Empty)
		{
			_conn.Open();
			SqlCommand command = new SqlCommand(String.Format("UPDATE States SET State='{0}', zonestate='{1}' where id='" + _userID + "'", dockState, zoneState), _conn);
			command.ExecuteNonQuery();
			_conn.Close();
		}

	}

	private RadDock CreateRadDockFromState(DockState state)
	{
		RadDock dock = new RadDock();
		dock.DockMode = DockMode.Docked;
		dock.ID = string.Format("RadDock{0}", state.UniqueName);
		dock.ApplyState(state);
		dock.Commands.Add(new DockCloseCommand());
		dock.Commands.Add(new DockExpandCollapseCommand());

		return dock;
	}

	private RadDock CreateRadDock()
	{
		int docksCount = CurrentDockStates.Count;

		RadDock dock = new RadDock();
		dock.DockMode = DockMode.Docked;
		dock.UniqueName = Guid.NewGuid().ToString().Replace('-', 'a');
		dock.ID = string.Format("RadDock{0}", dock.UniqueName);

		dock.Title = "Dock";
		dock.Text = string.Format("Added at {0}", DateTime.Now);
		dock.Width = Unit.Pixel(300);

		dock.Commands.Add(new DockCloseCommand());
		dock.Commands.Add(new DockExpandCollapseCommand());


		return dock;
	}

	private void CreateSaveStateTrigger(RadDock dock)
	{
		//Ensure that the RadDock control will initiate postback
		// when its position changes on the client or any of the commands is clicked.
		//Using the trigger we will "ajaxify" that postback.
		dock.AutoPostBack = true;
		dock.CommandsAutoPostBack = true;

		AsyncPostBackTrigger saveStateTrigger = new AsyncPostBackTrigger();
		saveStateTrigger.ControlID = dock.ID;
		saveStateTrigger.EventName = "DockPositionChanged";
		UpdatePanel1.Triggers.Add(saveStateTrigger);

		saveStateTrigger = new AsyncPostBackTrigger();
		saveStateTrigger.ControlID = dock.ID;
		saveStateTrigger.EventName = "Command";
		UpdatePanel1.Triggers.Add(saveStateTrigger);
	}

	private void LoadWidget(RadDock dock)
	{
		if (string.IsNullOrEmpty(dock.Tag))
		{
			return;
		}
		Control widget = LoadControl(dock.Tag);
		dock.ContentContainer.Controls.Add(widget);
	}


	protected void ButtonAddDock_Click(object sender, EventArgs e)
	{
		RadDock dock = CreateRadDock();
		//find the target zone and add the new dock there
		RadDockZone dz = RadDockLayout1.RegisteredZones[DropDownZone.SelectedIndex]; //(RadDockZone)FindControl(DropDownZone.SelectedItem.Text);
		dz.Controls.Add(dock);
		CreateSaveStateTrigger(dock);

		//Load the selected widget in the RadDock control
		dock.Tag = DroptDownWidget.SelectedValue;
		LoadWidget(dock);
	}

	private RadDockZone CreateZone()
	{
		RadDockZone zone = new RadDockZone();
		zone.UniqueName = Guid.NewGuid().ToString().Replace('-', 'a');
		zone.ID = String.Format("RadDockZone_{0}", zone.UniqueName);
		zone.Style.Add("float", "left");
		zone.Style.Add(HtmlTextWriterStyle.MarginRight, "10px");
		zone.MinHeight = Unit.Pixel(200);
		zone.Width = Unit.Pixel(300);

		return zone;
	}

	private RadDockZone CreateZoneFromState(string uniqueName)
	{
		RadDockZone zone = new RadDockZone();
		zone.UniqueName = uniqueName;
		zone.ID = String.Format("RadDockZone_{0}", zone.UniqueName);
		zone.Style.Add("float", "left");
		zone.Style.Add(HtmlTextWriterStyle.MarginRight, "10px");
		zone.MinHeight = Unit.Pixel(200);
		zone.Width = Unit.Pixel(300);

		return zone;
	}

	protected void ButtonAddZone_Click(object sender, EventArgs e)
	{
		RadDockZone zone = CreateZone();
		RadDockLayout1.Controls.Add(zone);
	}

	protected void ButtonPostBack_Click(object sender, EventArgs e)
	{
		//normal postback
	}
}
